<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_SupplementHotelType ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_SupplementHotelType extends AbstractStructArrayBase
{
    /**
     * The SupplementType
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_SupplementHotelType[]
     */
    public $SupplementType;
    /**
     * Constructor method for ArrayOfJP_SupplementHotelType
     * @uses ArrayOfJP_SupplementHotelType::setSupplementType()
     * @param \StructType\JP_SupplementHotelType[] $supplementType
     */
    public function __construct(array $supplementType = array())
    {
        $this
            ->setSupplementType($supplementType);
    }
    /**
     * Get SupplementType value
     * @return \StructType\JP_SupplementHotelType[]|null
     */
    public function getSupplementType()
    {
        return $this->SupplementType;
    }
    /**
     * This method is responsible for validating the values passed to the setSupplementType method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSupplementType method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSupplementTypeForArrayConstraintsFromSetSupplementType(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_SupplementHotelTypeSupplementTypeItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_SupplementHotelTypeSupplementTypeItem instanceof \StructType\JP_SupplementHotelType) {
                $invalidValues[] = is_object($arrayOfJP_SupplementHotelTypeSupplementTypeItem) ? get_class($arrayOfJP_SupplementHotelTypeSupplementTypeItem) : sprintf('%s(%s)', gettype($arrayOfJP_SupplementHotelTypeSupplementTypeItem), var_export($arrayOfJP_SupplementHotelTypeSupplementTypeItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SupplementType property can only contain items of type \StructType\JP_SupplementHotelType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SupplementType value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_SupplementHotelType[] $supplementType
     * @return \ArrayType\ArrayOfJP_SupplementHotelType
     */
    public function setSupplementType(array $supplementType = array())
    {
        // validation for constraint: array
        if ('' !== ($supplementTypeArrayErrorMessage = self::validateSupplementTypeForArrayConstraintsFromSetSupplementType($supplementType))) {
            throw new \InvalidArgumentException($supplementTypeArrayErrorMessage, __LINE__);
        }
        $this->SupplementType = $supplementType;
        return $this;
    }
    /**
     * Add item to SupplementType value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_SupplementHotelType $item
     * @return \ArrayType\ArrayOfJP_SupplementHotelType
     */
    public function addToSupplementType(\StructType\JP_SupplementHotelType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_SupplementHotelType) {
            throw new \InvalidArgumentException(sprintf('The SupplementType property can only contain items of type \StructType\JP_SupplementHotelType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SupplementType[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_SupplementHotelType|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_SupplementHotelType|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_SupplementHotelType|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_SupplementHotelType|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_SupplementHotelType|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SupplementType
     */
    public function getAttributeName()
    {
        return 'SupplementType';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_SupplementHotelType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
